<?php 

namespace Schaffen\SerasaRemessa\Cnab600;

class Shipping {
    private $header;
    private $details = [];
    private $trailer;

    public function __construct(array $config, array $persons) {
        $this->header = new Header($config);
        
        $sequence = 2;
        foreach($persons as $person) {
            $this->details[] = new Detail($this->header->getCnpjBranchDigit(), $person, $sequence);
            $sequence++;
        }

        $this->trailer = new Trailler($sequence);
    }

    public function getHeader() {
        return $this->header;
    }

    public function make() {
        $headerStirng = $this->makeHeader();
        $detailsString = $this->makeDetails();
        $trailerString = $this->makeTrailer();

        return $headerStirng . $detailsString . $trailerString;
    }

    private function makeHeader() {
        return $this->header->toString() . "\n";
    }
    private function makeDetails() {
        $detailsString = '';
        foreach( $this->details as $detail ) {
            $detailsString .= $detail->toString() . "\n";
        }

        return $detailsString;
    }

    private function makeTrailer() {
        return $this->trailer->toString();
    }
}